/* 
 * Proiect la PM - Joc de x si 0
 * Student Popescu Andreea
 * Grupa 333CB
*/
#define F_CPU 16000000

#include <avr/io.h>
#include <util/delay.h>


#define SUS		PD4
#define JOS		PD0
#define ST		PD6
#define DR 		PD5
#define OK		PD1

#define MG1		PA2
#define MG2		PA5
#define MG3     PC0
#define MG4     PA1
#define MG5     PA4
#define MG6     PA7
#define MG7     PA0
#define MG8		PA3
#define MG9		PA6

#define MP1		PB2
#define MP2		PB5
#define MP3     PC1
#define MP4     PB1
#define MP5     PB4
#define MP6     PB7
#define MP7     PB0
#define MP8		PB3
#define MP9		PB6


int matrice_g[4][4];	  		// 0-nu e selectat, 1-X
int matrice_p[4][4];	  		// 0-nu e selectat, 1-0
int matrice_poz_libere[4][4]; 	// 0-nu e ocupat, 1-e ocupat
int jucator = 1;	  			// 1-X, 0-0

typedef struct poz_cursor
{
	int x;
	int y;
};
struct poz_cursor cursor, pozitii[9];


void initializare()
{
	// initializare DDR
	DDRA |= 0b11111111;
	DDRB |= 0b11111111;
	DDRC |= 0b00000011;
	DDRD |= 0b00000000;
	
	// activare rezistente pull-up interne pentru butoane
	PORTD |= (1<<SUS)|(1<<JOS)|(1<<DR)|(1<<ST)|(1<<OK);
	
	int i,j;
	// initializare matrice valori si pozitie cursor pe prima pozitie
	for(i=1;i<=3;i++)
	for(j=1;j<=3;j++)
	{
		matrice_g[i][j]=0;
		matrice_p[i][j]=0;
		matrice_poz_libere[i][j]=0;
	}
	
	cursor.x=1;
	cursor.y=1;
}

void afisare_matrice()
{
	PORTA = (matrice_g[1][1]<<MG1)|(matrice_g[1][2]<<MG2)|\
	(matrice_g[2][1]<<MG4)|(matrice_g[2][2]<<MG5)|\
	(matrice_g[2][3]<<MG6)|(matrice_g[3][1]<<MG7)|\
	(matrice_g[3][2]<<MG8)|(matrice_g[3][3]<<MG9);
	
	PORTB = (matrice_p[1][1]<<MP1)|(matrice_p[1][2]<<MP2)|\
	(matrice_p[2][1]<<MP4)|(matrice_p[2][2]<<MP5)|\
	(matrice_p[2][3]<<MP6)|(matrice_p[3][1]<<MP7)|\
	(matrice_p[3][2]<<MP8)|(matrice_p[3][3]<<MP9);
	
	PORTC = (matrice_g[1][3]<<MG3)|(matrice_p[1][3]<<MP3);
}


void afisare_castigator(int juc, int tip, int locatie)
{
	int i,j,k;
	
	switch(tip)
	{
		case 1:  // linie castigatoare
		{
			if(juc==1)
			{
				i=0;
				while(i<5)
				{
					for(j=1;j<=3;j++)
					{
						matrice_g[locatie][j]=1;
					}
					
					afisare_matrice();
					_delay_ms(500);
					
					for(j=1;j<=3;j++)
					{
						matrice_g[locatie][j]=0;
					}
					
					afisare_matrice();
					_delay_ms(500);
					
					i++;
				}
			}
			else
			{
				i=0;
				while(i<5)
				{
					for(j=1;j<=3;j++)
					{
						matrice_p[locatie][j]=1;
					}
					
					afisare_matrice();
					_delay_ms(200);
					
					for(j=1;j<=3;j++)
					{
						matrice_p[locatie][j]=0;
					}
					
					afisare_matrice();
					_delay_ms(200);
					
					i++;
				}
			}
			break;
		}
		
		case 2:  // coloana castigatoare
		{
			if(juc==1)
			{
				i=0;
				while(i<5)
				{
					for(j=1;j<=3;j++)
					{
						matrice_g[j][locatie]=1;
					}
					
					afisare_matrice();
					_delay_ms(200);
					
					for(j=1;j<=3;j++)
					{
						matrice_g[j][locatie]=0;
					}
					
					afisare_matrice();
					_delay_ms(200);
					
					i++;
				}
			}
			else
			{
				i=0;
				while(i<5)
				{
					for(j=1;j<=3;j++)
					{
						matrice_p[j][locatie]=1;
					}
					
					afisare_matrice();
					_delay_ms(200);
					
					for(j=1;j<=3;j++)
					{
						matrice_p[j][locatie]=0;
					}
					
					afisare_matrice();
					_delay_ms(200);
					
					i++;
				}
			}
			break;
		}
		
		case 3:  // coloana castigatoare
		{
			if(juc==1)
			{
				i=0;
				while(i<5)
				{
					if(locatie==1)	// prima diagonala
					{
						matrice_g[1][1]=1;
						matrice_g[2][2]=1;
						matrice_g[3][3]=1;
					}
					else
					{
						matrice_g[1][3]=1;
						matrice_g[2][2]=1;
						matrice_g[3][1]=1;
					}
					
					afisare_matrice();
					_delay_ms(200);
					
					if(locatie==1)
					{
						matrice_g[1][1]=0;
						matrice_g[2][2]=0;
						matrice_g[3][3]=0;
					}
					else
					{
						matrice_g[1][3]=0;
						matrice_g[2][2]=0;
						matrice_g[3][1]=0;
					}
					
					afisare_matrice();
					_delay_ms(200);
					
					i++;
				}
			}
			else
			{
				i=0;
				while(i<5)
				{
					if(locatie==1)	// prima diagonala
					{
						matrice_p[1][1]=1;
						matrice_p[2][2]=1;
						matrice_p[3][3]=1;
					}
					else
					{
						matrice_p[1][3]=1;
						matrice_p[2][2]=1;
						matrice_p[3][1]=1;
					}
					
					afisare_matrice();
					_delay_ms(200);
					
					if(locatie==1)
					{
						matrice_p[1][1]=0;
						matrice_p[2][2]=0;
						matrice_p[3][3]=0;
					}
					else
					{
						matrice_p[1][3]=0;
						matrice_p[2][2]=0;
						matrice_p[3][1]=0;
					}
					
					afisare_matrice();
					_delay_ms(200);
					
					i++;
				}
			}
			break;
		}
		
		case 4:  // niciun castigator, se aprind toate ledurile
		{
			i=0;
			k=0;
			while(i<5)
			{
				for (j=1;j<=3;j++)
				for(k=1;k<=3;k++)
				{
					matrice_g[j][k]=1;
					matrice_p[j][k]=1;
				}
				
				afisare_matrice();
				_delay_ms(200);
				
				for (j=1;j<=3;j++)
				for(k=1;k<=3;k++)
				{
					matrice_g[j][k]=0;
					matrice_p[j][k]=0;
				}
				
				afisare_matrice();
				_delay_ms(200);
				
				i++;
			}
			break;
		}
		
	}
	
	
	for(i=1;i<=3;i++)
	for(j=1;j<=3;j++)
	{
		matrice_g[i][j]=0;
		matrice_p[i][j]=0;
	}
	
	
	afisare_matrice();
	_delay_ms(1000);
}

int verificare_castigator(int juc, int nr_poz_ramase)
{
	int j;
	
	if(juc==1)
	{
		if(matrice_g[1][3] == 1 && matrice_g[2][2] == 1 && matrice_g[3][1] == 1)
		{
			afisare_castigator(juc, 3, 2);	// 3-diagonala, 2-a doua diagonala
			return 1;
		}
		
		if(matrice_g[1][1] == 1 && matrice_g[2][2] == 1 && matrice_g[3][3] == 1)
		{
			afisare_castigator(juc, 3, 1);	// 3 diagonala, 2-1 prima diagonala
			return 1;
		}
		
		j=1;
		while(j<=3)
		{
			if(matrice_g[1][j]== 1 && matrice_g[2][j] == 1 && matrice_g[3][j] == 1)
			{
				afisare_castigator(juc, 2, j);	// 2-coloana, j-nr coloanei
				return 1;
			}
			
			if(matrice_g[j][1]== 1 && matrice_g[j][2] == 1 && matrice_g[j][3] == 1)
			{
				afisare_castigator(juc, 1, j);      // 1-linie , j-nr liniei
				return 1;
			}
			j++;
		}
	}
	else
	{
		if(matrice_p[1][3] == 1 && matrice_p[2][2] == 1 && matrice_p[3][1] == 1)
		{
			afisare_castigator(juc, 3, 2);	// 3-diagonala, 2-a doua diagonala
			return 1;
		}
		
		if(matrice_p[1][1] == 1 && matrice_p[2][2] == 1 && matrice_p[3][3] == 1)
		{
			afisare_castigator(juc, 3, 1);	// 3 diagonala, 2-1 prima diagonala
			return 1;
		}
		
		j=1;
		while(j<=3)
		{
			if(matrice_p[1][j]== 1 && matrice_p[2][j] == 1 && matrice_p[3][j] == 1)
			{
				afisare_castigator(juc, 2, j);	// 2-coloana, j-nr coloanei
				return 1;
			}
			
			if(matrice_p[j][1]== 1 && matrice_p[j][2] == 1 && matrice_p[j][3] == 1)
			{
				afisare_castigator(juc, 1, j);      // 1-linie , j-nr liniei
				return 1;
			}

			j++;
		}
		
	}
	
	if(nr_poz_ramase == 1)	// acesta a fost ultimul element liber de pe tabela si nu avem castigator
	{
		afisare_castigator(juc,4,0);
		return 1;
	}
	
	return 0;
}


int afisare_cursor()
{
	int i,j,nr_poz_libere=0,ok=0, pozitie_curenta=0;
	
	// Memorez pozitiile libere in care pot amplasa X sau 0
	for(i=1;i<=3;i++)
	for(j=1;j<=3;j++)
	{
		if(matrice_poz_libere[i][j]==0)
		{
			pozitii[nr_poz_libere].x=i;
			pozitii[nr_poz_libere].y=j;
			nr_poz_libere++;
		}
	}
	
	// Pozitionez cursorul pe prima pozitie libera
	cursor.x=pozitii[0].x;
	cursor.y=pozitii[0].y;
	
	while(1)
	{
		if(jucator==1)
		{
			matrice_g[cursor.x][cursor.y]=1;
			_delay_ms(150);
			afisare_matrice();
			matrice_g[cursor.x][cursor.y]=0;
			_delay_ms(150);
			afisare_matrice();
		}
		else
		{
			matrice_p[cursor.x][cursor.y]=1;
			_delay_ms(150);
			afisare_matrice();
			matrice_p[cursor.x][cursor.y]=0;
			_delay_ms(150);
			afisare_matrice();
		}
		
		for(i=0;i<nr_poz_libere;i++)
		if(pozitii[i].x == cursor.x && pozitii[i].y == cursor.y)
		pozitie_curenta = i;
		
		
		if(!(PIND & (1<<SUS)))
		{
			if(jucator==1)
			matrice_g[cursor.x][cursor.y]=0;
			else
			matrice_p[cursor.x][cursor.y]=0;
			
			j=cursor.x-1;
			ok=0;
			while(j>0)
			{
				for(i=0;i<nr_poz_libere;i++)
				if(pozitii[i].y==cursor.y && pozitii[i].x==j && !ok)
				{
					cursor.x=pozitii[i].x;
					ok=1;
				}
				j--;
			}
			
			if(ok==0)	// nu s-a gasit o pozitie unde sa-l mute(e blocat)
			{
				if(pozitie_curenta>0)
				{
					cursor.x = pozitii[pozitie_curenta-1].x;
					cursor.y = pozitii[pozitie_curenta-1].y;
				}
				else
				{
					cursor.x = pozitii[nr_poz_libere-1].x;
					cursor.y = pozitii[nr_poz_libere-1].y;
				}
			}
		}
		
		if(!(PIND & (1<<JOS)))
		{
			if(jucator==1)
			matrice_g[cursor.x][cursor.y]=0;
			else
			matrice_p[cursor.x][cursor.y]=0;
			
			j=cursor.x+1;
			ok=0;
			while(j<4)
			{
				for(i=0;i<nr_poz_libere;i++)
				if(pozitii[i].y==cursor.y && pozitii[i].x==j && !ok)
				{
					cursor.x=pozitii[i].x;
					ok=1;
				}
				j++;
			}
			
			if(ok==0)	// nu s-a gasit o pozitie unde sa-l mute(e blocat)
			{
				if(pozitie_curenta<nr_poz_libere-1)
				{
					cursor.x = pozitii[pozitie_curenta+1].x;
					cursor.y = pozitii[pozitie_curenta+1].y;
				}
				else
				{
					cursor.x = pozitii[0].x;
					cursor.y = pozitii[0].y;
				}
			}
		}
		
		if(!(PIND & (1<<ST)))
		{
			if(jucator==1)
			matrice_g[cursor.x][cursor.y]=0;
			else
			matrice_p[cursor.x][cursor.y]=0;
			
			j=cursor.y-1;
			ok=0;
			while(j>0)
			{
				for(i=0;i<nr_poz_libere;i++)
				if(pozitii[i].x==cursor.x && pozitii[i].y==j && !ok)
				{
					cursor.y=pozitii[i].y;
					ok=1;
				}
				j--;
			}
			
			if(ok==0)	// nu s-a gasit o pozitie unde sa-l mute(e blocat)
			{
				if(pozitie_curenta>0)
				{
					cursor.x = pozitii[pozitie_curenta-1].x;
					cursor.y = pozitii[pozitie_curenta-1].y;
				}
				else
				{
					cursor.x = pozitii[nr_poz_libere-1].x;
					cursor.y = pozitii[nr_poz_libere-1].y;
				}
			}
		}
		
		if(!(PIND & (1<<DR)))
		{
			if(jucator==1)
			matrice_g[cursor.x][cursor.y]=0;
			else
			matrice_p[cursor.x][cursor.y]=0;
			
			j=cursor.y+1;
			ok=0;
			while(j<4)
			{
				for(i=0;i<nr_poz_libere;i++)
				if(pozitii[i].x==cursor.x && pozitii[i].y==j && !ok)
				{
					cursor.y=pozitii[i].y;
					ok=1;
				}
				j++;
			}
			
			if(ok==0)	// nu s-a gasit o pozitie unde sa-l mute(e blocat)
			{
				if(pozitie_curenta<nr_poz_libere-1)
				{
					cursor.x = pozitii[pozitie_curenta+1].x;
					cursor.y = pozitii[pozitie_curenta+1].y;
				}
				else
				{
					cursor.x = pozitii[0].x;
					cursor.y = pozitii[0].y;
				}
			}
		}
		
		if(!(PIND & (1<<OK)))
		{
			if(jucator==1)
			{
				matrice_g[cursor.x][cursor.y]=1;
				jucator=0;
				if(verificare_castigator(1, nr_poz_libere)==1)
				return 1;
			}
			else
			{
				matrice_p[cursor.x][cursor.y]=1;
				jucator=1;
				if(verificare_castigator(0, nr_poz_libere)==1)
				return 1;
			}
			
			matrice_poz_libere[cursor.x][cursor.y]=1;
			break;
		}
	}
	return 0;
}



int main()
{
	// initializare registrii si variabile
	initializare();
	int i,j;
	
	while (1)
	{
		if(afisare_cursor()==1)	// daca s-a detectat un castigator sau s-a terminat remiza
		{
			// reinitializare matrice valori si pozitie cursor pe prima pozitie
			for(i=1;i<=3;i++)
			for(j=1;j<=3;j++)
			{
				matrice_g[i][j]=0;
				matrice_p[i][j]=0;
				matrice_poz_libere[i][j]=0;
			}
			
			for(i=0;i<9;i++)
			{
				pozitii[i].x=0;
				pozitii[i].y=0;
			}
			
			cursor.x=1;
			cursor.y=1;
			
			jucator=1;
		}
	}
	
	return 0;
}
